Index: src/Fl_Widget.cxx
===================================================================
--- src/Fl_Widget.cxx	(revision 6732)
+++ src/Fl_Widget.cxx	(working copy)
@@ -106,6 +106,11 @@
   align_	 = FL_ALIGN_CENTER;
   when_		 = FL_WHEN_RELEASE;
 
+#ifdef FL_HAVE_MSAA
+  // Initialize MSAA stuff
+  msaa_proxy_	 = 0;
+#endif // FL_HAVE_MSAA
+
   parent_ = 0;
   if (Fl_Group::current()) Fl_Group::current()->add(this);
 }
@@ -150,6 +155,10 @@
 #endif // DEBUG_DELETE
   parent_ = 0; // Don't throw focus to a parent widget.
   fl_throw_focus(this);
+
+#ifdef FL_HAVE_MSAA
+  msaa_cleanup();
+#endif // FL_HAVE_MSAA
 }
 
 /** Draws a focus box for the widget at the given position and size */
@@ -235,6 +244,9 @@
       redraw();
       redraw_label();
       handle(FL_SHOW);
+#ifdef FL_HAVE_MSAA
+      msaa_notify(EVENT_OBJECT_SHOW);
+#endif // FL_HAVE_MSAA
       if (inside(Fl::focus())) Fl::focus()->take_focus();
     }
   }
@@ -246,6 +258,9 @@
     for (Fl_Widget *p = parent(); p; p = p->parent())
       if (p->box() || !p->parent()) {p->redraw(); break;}
     handle(FL_HIDE);
+#ifdef FL_HAVE_MSAA
+    msaa_notify(EVENT_OBJECT_HIDE);
+#endif // FL_HAVE_MSAA
     fl_throw_focus(this);
   } else {
     set_flag(INVISIBLE);
@@ -277,6 +292,9 @@
   }
   label_.value=a;
   redraw_label();
+#ifdef FL_HAVE_MSAA
+  msaa_notify(EVENT_OBJECT_NAMECHANGE);
+#endif // FL_HAVE_MSAA
 }
 
 
@@ -291,6 +309,9 @@
     label_.value=(char *)0;
   }
   redraw_label();
+#ifdef FL_HAVE_MSAA
+  msaa_notify(EVENT_OBJECT_NAMECHANGE);
+#endif // FL_HAVE_MSAA
 }
 
 /** Calls the widget callback.
@@ -310,6 +331,1205 @@
     clear_changed();
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+#include <FL/Fl_Multi_Label.H>
+#include <FL/x.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+/*----------------------- IEnumVARIANT implementation ----------------------*/
+
+class Fl_Msaa_Enum : public IEnumVARIANT
+{
+private:
+  LONG		mRefCount;	// Reference counter
+  unsigned long mPos;		// Current read offset in array
+  unsigned long mSize;		// Number of items in array
+  VARIANT*      mpItems;	// Storage for items
+
+  Fl_Msaa_Enum(Fl_Msaa_Enum& src);
+  void InitObject(size_t size);
+
+public:
+  Fl_Msaa_Enum(long* ids, size_t count);
+  virtual ~Fl_Msaa_Enum();
+
+  // IUnknown implementation
+  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void**);
+  ULONG STDMETHODCALLTYPE AddRef();
+  ULONG STDMETHODCALLTYPE Release();
+
+  // IEnumVARIANT implementation
+  HRESULT STDMETHODCALLTYPE Next(unsigned long, VARIANT*, unsigned long*);
+  HRESULT STDMETHODCALLTYPE Skip(unsigned long);
+  HRESULT STDMETHODCALLTYPE Reset();
+  HRESULT STDMETHODCALLTYPE Clone(IEnumVARIANT**);
+};
+
+
+void
+Fl_Msaa_Enum::InitObject(size_t size)
+{
+  mRefCount = 0;
+  mPos      = 0;
+  mSize     = size;
+  mpItems   = size ? (VARIANT*)malloc(sizeof(VARIANT) * size) : NULL;
+  for (VARIANT* ptr = mpItems;  size--;  ++ptr)  flVariantClear(ptr);
+}
+
+
+Fl_Msaa_Enum::Fl_Msaa_Enum(Fl_Msaa_Enum& src)
+{
+  InitObject(src.mSize);
+
+  // Perform full copy
+  VARIANT* sptr = src.mpItems;
+  VARIANT* dptr = mpItems;
+  mPos = src.mPos;
+  for (mSize = 0;  mSize < src.mSize;  ++mSize, ++sptr, ++dptr)
+    flVariantCopy(dptr, sptr);
+}
+
+
+Fl_Msaa_Enum::Fl_Msaa_Enum(long* ids, size_t count)
+{
+  InitObject(count);
+
+  // Setup an array of VT_I4
+  for (VARIANT* ptr = mpItems;  count--;  ++ptr, ++ids)
+  {
+    ptr->vt   = VT_I4;
+    ptr->lVal = *ids;
+  }
+}
+
+
+Fl_Msaa_Enum::~Fl_Msaa_Enum()
+{
+  if (!mpItems)  return;
+  for (VARIANT* ptr = mpItems;  mSize--;  ++ptr)  flVariantClear(ptr);
+  free(mpItems);
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Enum::QueryInterface(
+    /* [in] */ REFIID riid,
+    /* [iid_is][out] */ void** ppvObject)
+{
+  // Reject unsupported interfaces
+  if ((riid == IID_IEnumVARIANT) ||
+      (riid == IID_IUnknown))
+  {
+    // Add reference for supported interfaces
+    *ppvObject = this;
+    ((LPUNKNOWN)*ppvObject)->AddRef();
+    return S_OK;
+  }
+
+  *ppvObject = NULL;
+  return E_NOINTERFACE;
+}
+
+
+ULONG STDMETHODCALLTYPE
+Fl_Msaa_Enum::AddRef()
+{
+  return InterlockedIncrement(&mRefCount);
+}
+
+
+ULONG STDMETHODCALLTYPE
+Fl_Msaa_Enum::Release()
+{
+  ULONG count = InterlockedDecrement(&mRefCount);
+  if (count == 0)  delete this;
+  return count;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Enum::Next(unsigned long count, VARIANT* pvar, unsigned long* pFetched)
+{
+  if (!pvar)  return E_INVALIDARG;
+
+  // Determine final read offset and number of items fetched
+  unsigned long end = mPos + count;
+  if (end > mSize)  end = mSize;
+  unsigned long fetched = end - mPos;
+
+  // Perform actual copy
+  VARIANT* dst = pvar;
+  for (VARIANT* ptr = mpItems + mPos;  mPos < end;  ++ptr, ++mPos, ++dst)
+  {
+    HRESULT result = flVariantCopy(dst, ptr);
+    if (S_OK == result)  continue;
+
+    // Encountered error, clean up partial copy and exit
+    for (dst = pvar;  count--;  ++dst)  flVariantClear(dst);
+    return result;
+  }
+
+  // Report result to caller
+  if (pFetched)  *pFetched = fetched;
+  return (fetched == count) ? S_OK : S_FALSE;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Enum::Skip(unsigned long count)
+{
+  mPos += count;
+  if (mPos > mSize)
+  {
+    // Report failure when skipping outside array
+    mPos = mSize;
+    return S_FALSE;
+  }
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Enum::Reset()
+{
+  mPos = 0;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Enum::Clone(IEnumVARIANT** ppvar)
+{
+  // Check for valid destination variable
+  if (!ppvar)  return E_INVALIDARG;
+
+  // Copy self and Check for out of memory condition
+  *ppvar = new Fl_Msaa_Enum(*this);
+  if (!*ppvar)  return E_OUTOFMEMORY;
+
+  // Increase reference count
+  (*ppvar)->AddRef();
+  return S_OK;
+}
+
+
+/*--------------------- MSAA proxy for Fl_Widget object --------------------*/
+
+Fl_Msaa_Proxy::~Fl_Msaa_Proxy()
+{
+  OverrideParent(NULL);
+}
+
+
+void
+Fl_Msaa_Proxy::OverrideParent(Fl_Msaa_Proxy* parent)
+{
+  if (parent)  parent->AddRef();
+  if (mpParent)  mpParent->Release();
+  mpParent = parent;
+}
+
+
+long
+Fl_Msaa_Proxy::LookupChild(Fl_Widget* o)
+{
+  if (!mpObj)  return -1;
+  return mpObj->msaa_child_id(o);
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::QueryInterface(
+    /* [in] */ REFIID riid,
+    /* [iid_is][out] */ void** ppvObject)
+{
+  // Reject unsupported interfaces
+  if ((riid == IID_IAccessible) ||
+      (riid == IID_IDispatch) ||
+      (riid == IID_IUnknown))
+  {
+    // Add reference for supported interfaces
+    *ppvObject = this;
+    ((LPUNKNOWN)*ppvObject)->AddRef();
+    return S_OK;
+  }
+
+  *ppvObject = NULL;
+  return E_NOINTERFACE;
+}
+
+
+ULONG STDMETHODCALLTYPE
+Fl_Msaa_Proxy::AddRef()
+{
+  return InterlockedIncrement(&mRefCount);
+}
+
+
+ULONG STDMETHODCALLTYPE
+Fl_Msaa_Proxy::Release()
+{
+  ULONG count = InterlockedDecrement(&mRefCount);
+  if (count == 0)  delete this;
+  return count;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::GetTypeInfoCount(
+    /* [out] */ UINT* pctinfo)
+{
+  *pctinfo = 0;
+  return E_NOTIMPL;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::GetTypeInfo(
+    /* [in] */ UINT iTInfo,
+    /* [in] */ LCID lcid,
+    /* [out] */ ITypeInfo** ppTInfo)
+{
+  *ppTInfo = 0;
+  return E_NOTIMPL;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::GetIDsOfNames(
+    /* [in] */ REFIID riid,
+    /* [size_is][in] */ LPOLESTR* rgszNames,
+    /* [in] */ UINT cNames,
+    /* [in] */ LCID lcid,
+    /* [size_is][out] */ DISPID* rgDispId)
+{
+  *rgDispId = 0;
+  return E_NOTIMPL;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::Invoke(
+    /* [in] */ DISPID dispIdMember,
+    /* [in] */ REFIID riid,
+    /* [in] */ LCID lcid,
+    /* [in] */ WORD wFlags,
+    /* [out][in] */ DISPPARAMS* pDispParams,
+    /* [out] */ VARIANT* pVarResult,
+    /* [out] */ EXCEPINFO* pExcepInfo,
+    /* [out] */ UINT* puArgErr)
+{
+  *puArgErr = 0;
+  return E_NOTIMPL;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accParent(
+    /* [retval][out] */ IDispatch** ppdispParent)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!ppdispParent)  return E_INVALIDARG;
+  *ppdispParent = NULL;
+
+  if (mpParent)
+  {
+    mpParent->QueryInterface(IID_IDispatch, (void**)ppdispParent);
+    return S_OK;
+  }
+  if (!mpObj->msaa_parent(ppdispParent))  return S_FALSE;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accChildCount(
+    /* [retval][out] */ long* pcountChildren)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pcountChildren)  return E_INVALIDARG;
+
+  *pcountChildren = mpObj->msaa_child_count();
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accChild(
+    /* [in] */ VARIANT varChild,
+    /* [retval][out] */ IDispatch** ppdispChild)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (varChild.vt != VT_I4)  return E_INVALIDARG;
+  if (!ppdispChild)  return E_INVALIDARG;
+  *ppdispChild = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  Fl_Msaa_Proxy* proxy = mpObj->msaa_child(id);
+  if (!proxy)  return S_FALSE;
+  proxy->QueryInterface(IID_IDispatch, (void**)ppdispChild);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accName(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszName)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pszName)  return E_INVALIDARG;
+  *pszName = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_name(id, pszName))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszValue)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pszValue)  return E_INVALIDARG;
+  *pszValue = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_value(id, pszValue))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accDescription(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDescription)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDescription)  return E_INVALIDARG;
+  *pszDescription = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_description(id, pszDescription))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accRole(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarRole)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarRole)  return E_INVALIDARG;
+  pvarRole->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  pvarRole->vt   = VT_I4;
+  pvarRole->lVal = mpObj->msaa_role(id);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accState(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarState)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarState)  return E_INVALIDARG;
+  pvarState->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  pvarState->vt   = VT_I4;
+  pvarState->lVal = mpObj->msaa_state(id);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accHelp(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszHelp)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelp)  return E_INVALIDARG;
+  *pszHelp = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_help(id, pszHelp))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accHelpTopic(
+    /* [out] */ BSTR* pszHelpFile,
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ long* pidTopic)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelpFile)  return E_INVALIDARG;
+  if (!pidTopic)  return E_INVALIDARG;
+  *pszHelpFile = NULL;
+  *pidTopic = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_help_topic(id, pszHelpFile, pidTopic))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accKeyboardShortcut(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszKeyboardShortcut)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pszKeyboardShortcut)  return E_INVALIDARG;
+  *pszKeyboardShortcut = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_shortcut(id, pszKeyboardShortcut))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accFocus(
+    /* [retval][out] */ VARIANT *pvarChild)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  long id = mpObj->msaa_focus();
+  if (id < 0)  return S_OK;
+
+  // Try to obtain child proxy
+  if (id > 0)
+  {
+    Fl_Msaa_Proxy* proxy = mpObj->msaa_child(id);
+    if (proxy)
+    {
+      pvarChild->vt = VT_DISPATCH;
+      proxy->QueryInterface(IID_IDispatch, (void**)&pvarChild->pdispVal);
+      return S_OK;
+    }
+  }
+
+  // Otherwise return child ID
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = id;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accSelection(
+    /* [retval][out] */ VARIANT* pvarChildren)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChildren)  return E_INVALIDARG;
+
+  // Put selection inside VARIANT
+  mpObj->msaa_selection(pvarChildren);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::get_accDefaultAction(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDefaultAction)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDefaultAction)  return E_INVALIDARG;
+  *pszDefaultAction = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_action(id, pszDefaultAction))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::accSelect(
+    /* [in] */ long flagsSelect,
+    /* [optional][in] */ VARIANT varChild)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (flagsSelect == SELFLAG_NONE)  return S_OK;
+  if (!mpObj->msaa_do_select(id, flagsSelect))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::accLocation(
+    /* [out] */ long* pxLeft,
+    /* [out] */ long* pyTop,
+    /* [out] */ long* pcxWidth,
+    /* [out] */ long* pcyHeight,
+    /* [optional][in] */ VARIANT varChild)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pxLeft || !pyTop || !pcxWidth || !pcyHeight)  return E_INVALIDARG;
+  *pxLeft    = 0;
+  *pyTop     = 0;
+  *pcxWidth  = 0;
+  *pcyHeight = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_location(id, pxLeft, pyTop, pcxWidth, pcyHeight))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::accNavigate(
+    /* [in] */ long navDir,
+    /* [optional][in] */ VARIANT varStart,
+    /* [retval][out] */ VARIANT* pvarEndUpAt)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarEndUpAt)  return E_INVALIDARG;
+  pvarEndUpAt->vt = VT_EMPTY;
+  long id = (varStart.vt == VT_I4 ? varStart.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+  if ((id != 0) &&
+      ((navDir == NAVDIR_FIRSTCHILD) || (navDir == NAVDIR_LASTCHILD)))
+    return DISP_E_MEMBERNOTFOUND;
+
+  // Handle navigation relative to widget itself
+  if ((id == 0) &&
+      (navDir != NAVDIR_FIRSTCHILD) && (navDir != NAVDIR_LASTCHILD))
+  {
+    // Forward request to parent widget
+    Fl_Msaa_Proxy* proxy;
+    if (mpParent)  proxy = mpParent;
+    else
+    {
+      Fl_Group* parent_obj = mpObj->parent();
+      if (!parent_obj)  return DISP_E_MEMBERNOTFOUND;
+      proxy = parent_obj->msaa_as_parent();
+    }
+    if (!proxy)  return DISP_E_MEMBERNOTFOUND;
+    VARIANT self;
+    self.vt   = VT_I4;
+    self.lVal = proxy->LookupChild(mpObj);
+    if (self.lVal < 1)  return DISP_E_MEMBERNOTFOUND;
+    return proxy->accNavigate(navDir, self, pvarEndUpAt);
+  }
+
+  // Handle navigation between child items
+  long dst = mpObj->msaa_navigate(id, navDir);
+  if (dst < 0)  return DISP_E_MEMBERNOTFOUND;
+  Fl_Msaa_Proxy* proxy = mpObj->msaa_child(dst);
+  if (!proxy)
+  {
+    pvarEndUpAt->vt   = VT_I4;
+    pvarEndUpAt->lVal = dst;
+  }
+  else
+  {
+    pvarEndUpAt->vt = VT_DISPATCH;
+    proxy->QueryInterface(IID_IDispatch, (void**)&pvarEndUpAt->pdispVal);
+  }
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::accHitTest(
+    /* [in] */ long xLeft,
+    /* [in] */ long yTop,
+    /* [retval][out] */ VARIANT* pvarChild)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  // Make sure the point is inside this widget
+  long X, Y, W, H;
+  if (!mpObj->msaa_location(0, &X, &Y, &W, &H))  return S_FALSE;
+  if ((xLeft < X) || (xLeft >= (X + W)))  return S_FALSE;
+  if ((yTop < Y) || (yTop >= (Y + H)))  return S_FALSE;
+
+  // Check child elements from top to bottom
+  VARIANT self;
+  self.vt   = VT_I4;
+  self.lVal = 0;
+  for (int n = mpObj->msaa_child_count();  n > 0;  --n)
+  {
+    // Obtain location through proxy first, but fall back to function call
+    Fl_Msaa_Proxy* proxy = mpObj->msaa_child(n);
+    if (proxy && (proxy->accLocation(&X, &Y, &W, &H, self) != S_OK))
+      continue;
+    else if (!proxy && !mpObj->msaa_location(n, &X, &Y, &W, &H))
+      continue;
+
+    // Make sure point is inside child object
+    if ((xLeft < X) || (xLeft >= (X + W)))  continue;
+    if ((yTop < Y) || (yTop >= (Y + H)))  continue;
+
+    // Setup result
+    if (proxy)
+    {
+      pvarChild->vt = VT_DISPATCH;
+      proxy->QueryInterface(IID_IDispatch, (void**)&pvarChild->pdispVal);
+    }
+    else
+    {
+      pvarChild->vt   = VT_I4;
+      pvarChild->lVal = n;
+    }
+    return S_OK;
+  }
+
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = 0;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::accDoDefaultAction(
+    /* [optional][in] */ VARIANT varChild)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  if (!mpObj->msaa_do_action(id))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::put_accName(
+    /* [optional][in] */ VARIANT varChild,
+    /* [in] */ BSTR szName)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  return E_NOTIMPL;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Proxy::put_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [in] */ BSTR szValue)
+{
+  if (!mpObj)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > mpObj->msaa_child_count())  return E_INVALIDARG;
+
+  char* value = fl_bstr_to_str(szValue);
+  bool ok = mpObj->msaa_put_value(id, value);
+  fl_free_str(value);
+  return (ok ? S_OK : DISP_E_MEMBERNOTFOUND);
+}
+
+
+/*-------------------------- BSTR utility functions -----------------------*/
+
+void
+fl_str_to_bstr(const char* str, int len, BSTR* bstr)
+{
+  if (!str)  str = "";
+  if (len < 0)  len = strlen(str);
+  DWORD blen = MultiByteToWideChar(CP_UTF8, 0, str, len, 0, 0);
+  *bstr = flSysAllocStringLen(0, blen);
+  if (*bstr)  MultiByteToWideChar(CP_UTF8, 0, str, len, *bstr, blen);
+}
+
+
+char*
+fl_bstr_to_str(const BSTR bstr, size_t* pLen)
+{
+  DWORD blen = flSysStringLen(bstr);
+  int len;
+  if (blen)  len = WideCharToMultiByte(CP_UTF8, 0, bstr, blen, 0, 0, 0, 0);
+  else       len = 0;
+  CHAR* str = (CHAR*)malloc(len + 1); 
+  if (str)
+  {
+    if (len)  WideCharToMultiByte(CP_UTF8, 0, bstr, blen, str, len, 0, 0);
+    str[len] = '\0';
+  }
+  if (pLen)  *pLen = len;
+  return (char*)str;
+}
+
+
+static const char*
+fl_symbol_to_text(const char* symbol)
+{
+  if (*symbol != '@')  return symbol;
+
+  const char* p = symbol + 1;
+  if (*p == '@')  return p;
+  if (*p == '#')  ++p;
+  if ((*p == '-' || *p == '+') && (p[1] >= '1' || p[1] <= '9'))  p += 2;
+
+  bool flip_x = false;
+  if (*p == '$')
+  {
+    flip_x = true;
+    ++p;
+  }
+
+  bool flip_y = false;
+  if (*p == '%')
+  {
+    flip_y = true;
+    ++p;
+  }
+
+  int angle = 0;
+  switch (*p++)
+  {
+    case '0':
+      angle = 100*(p[1]-'0') + 10*(p[2]-'0') + (p[3]-'0');
+      if (angle > 360)  angle %= 360; 
+      angle = angle - (angle % 45);
+      p += 3;
+      break;
+    case '1':  angle = 225;  break;
+    case '2':  angle = 270;  break;
+    case '3':  angle = 315;  break;
+    case '4':  angle = 180;  break;
+    case '5':  break;
+    case '6':  break;
+    case '7':  angle = 135;  break;
+    case '8':  angle =  90;  break;
+    case '9':  angle =  45;  break;
+    default:   p--;  break;
+  }
+
+  // Handle special symbols
+  const char* special[] =
+  {
+    "search",		"Search",
+    "FLTK",		"FLTK",
+    "filenew",		"New File",
+    "fileopen",		"Open File",
+    "filesave",		"Save",
+    "filesaveas",	"Save As",
+    "fileprint",	"Print",
+    "refresh",		"Refresh",
+    "reload",		"Reload",
+    "undo",		"Undo",
+    "redo",		"Redo",
+    NULL
+  };
+  for (const char** ptr = special;  *ptr;  ptr += 2)
+  {
+    size_t len = strlen(ptr[0]);
+    if (strncmp(p, ptr[0], len))  continue;
+    if (p[len] && !isspace(p[len]))  continue;
+    return ptr[1];
+  }
+
+  // Treat left-arrows as arrows rotated by 180 degrees
+  const char* left_arrows[] = {"<-", "<", "<<", "|<", "[]<", "<|", NULL};
+  for (const char** ptr = left_arrows;  *ptr;  ++ptr)
+  {
+    if (0 == strncmp(p, *ptr, strlen(*ptr)))
+    {
+      angle = (180 + angle) % 360;
+      break;
+    }
+  }
+
+  // Adjust angle due to flipping
+  if (flip_x)  angle = (540 - angle) % 360;
+  if (flip_y)  angle = (360 - angle) % 360;
+
+  // Obtain name based on angle now
+  switch (angle)
+  {
+    case   0:  return "Right";
+    case  45:  return "Top Right";
+    case  90:  return "Up";
+    case 135:  return "Top Left";
+    case 180:  return "Left";
+    case 225:  return "Bottom Left";
+    case 270:  return "Down";
+    case 315:  return "Bottom Right";
+    default:   return symbol;
+  }
+}
+
+
+char*
+fl_label_to_text(const char* label, size_t* pLen)
+{
+  if (!label)  label = "";
+  char* text = (char*)malloc(strlen(label) + 1);
+  char* ptr = text;
+  bool  escaped = false;
+  for (;  *label;  label++)
+  {
+    if (!escaped && (*label == '&'))  escaped = true;
+    else
+    {
+      *ptr++ = *label;
+      escaped = false;
+    }
+  }
+  *ptr = '\0';
+  if (pLen)  *pLen = ptr - text;
+  return text;
+}
+
+
+char*
+fl_label_to_shortcut(const char* label, size_t* pLen)
+{
+  if (!label)  label = "";
+  if (*label == '@')
+  {
+    // Skip up to spacing character
+    while (*label && !isspace(*label))  ++label;
+  }
+  char* shortcut = (char*)malloc(2);
+  char* ptr = shortcut;
+  bool  escaped = false;
+  for (;  *label;  label++)
+  {
+    if (escaped)
+    {
+      *ptr++ = tolower(*label);
+      break;
+    }
+    else if (*label == '&')  escaped = true;
+  }
+  *ptr = '\0';
+  if (pLen)  *pLen = ptr - shortcut;
+  return shortcut;
+}
+
+
+const char*
+fl_label_string(int l_type, const char* l_text)
+{
+  switch (l_type)
+  {
+    case FL_NORMAL_LABEL:
+    case _FL_SHADOW_LABEL:
+    case _FL_ENGRAVED_LABEL:
+    case _FL_EMBOSSED_LABEL:
+      // All other label types have no textual name
+      return l_text;
+
+    case _FL_MULTI_LABEL:
+      // Search for text in multi label recursively
+      {
+	Fl_Multi_Label* multi = (Fl_Multi_Label*)l_text;
+	const char* l = fl_label_string(multi->typea, multi->labela);
+	if (l)  return l;
+	else  return fl_label_string(multi->typeb, multi->labelb);
+      }
+
+    default:
+      // All other label types have no textual name
+      return NULL;
+  }
+}
+
+
+void
+fl_free_str(char* str)
+{
+  free(str);
+}
+
+
+/*------------------------- Fl_Widget MSAA support -------------------------*/
+
+void
+Fl_Widget::msaa_show_caret(long X, long Y, long W, long H)
+{
+  // Show caret in parent window
+  const Fl_Window* wnd = msaa_window();
+  if (wnd)  wnd->msaa_set_caret(X, Y, W, H);
+}
+
+
+void
+Fl_Widget::msaa_hide_caret()
+{
+  // Show caret in parent window
+  const Fl_Window* wnd = msaa_window();
+  if (wnd)  wnd->msaa_set_caret(0, 0, 0, 0);
+}
+
+
+void
+Fl_Widget::msaa_convert_selection(long* ids, size_t count, VARIANT* pvar)
+{
+  if (!pvar)  return;
+
+  if (!ids || !count)
+  {
+    // Empty selection
+    pvar->vt = VT_EMPTY;
+  }
+  else if (count == 1)
+  {
+    // Convert single selection as simple element
+    pvar->vt   = VT_I4;
+    pvar->lVal = ids[0];
+  }
+  else
+  {
+    // Convert multi-selection to IEnumVARIANT
+    Fl_Msaa_Enum* enumvar = new Fl_Msaa_Enum(ids, count);
+    if (!enumvar)  return;
+    pvar->vt = VT_UNKNOWN;
+    enumvar->QueryInterface(IID_IUnknown, (void**)&pvar->punkVal);
+  }
+}
+
+
+void
+Fl_Widget::msaa_cleanup()
+{
+  // Detach MSAA proxy object and release reference
+  if (msaa_proxy_)
+  {
+    msaa_proxy_->Detach();
+    msaa_proxy_->Release();
+  }
+}
+
+
+bool
+Fl_Widget::msaa_parent(IDispatch** dispatch)
+{
+  Fl_Group* p = parent();
+  if (p)
+  {
+    // Traversing inside FLTK hierarchy
+    Fl_Msaa_Proxy* proxy = p->msaa_as_parent();
+    if (!proxy)  return false;
+    proxy->QueryInterface(IID_IDispatch, (void**)dispatch);
+    return true;
+  }
+  else
+  {
+    // Moving outside FLTK hierarchy
+    const Fl_Window* wnd = msaa_window();
+    if (!wnd)  return false;
+    HWND hwnd = fl_xid(wnd);
+    if (!hwnd)  return false;
+    return S_OK == flAccessibleObjectFromWindow(hwnd, OBJID_WINDOW,
+	IID_IDispatch, (void**)dispatch);
+  }
+}
+
+
+Fl_Msaa_Proxy*
+Fl_Widget::msaa_child(long id)
+{
+  if (id > 0)  return NULL;
+
+  // Allow some widgets to be represented as simple elements
+  if (!msaa_use_proxy())  return NULL;
+
+  if (!msaa_proxy_)
+  {
+    // Link an IAccessible proxy to this widget
+    msaa_proxy_ = new Fl_Msaa_Proxy(this);
+    if (msaa_proxy_)  msaa_proxy_->AddRef();
+  }
+  return msaa_proxy_;
+}
+
+
+bool
+Fl_Widget::msaa_name(long id, BSTR* bstr)
+{
+  const char* l = fl_label_string(label_.type, label_.value);
+  if (!l)  l = "";
+  if (*l == '@')
+  {
+    // Handle symbol strings
+    fl_str_to_bstr(fl_symbol_to_text(l), -1, bstr);
+    return true;
+  }
+  size_t len;
+  char* str = fl_label_to_text(l, &len);
+  fl_str_to_bstr(str, len, bstr);
+  fl_free_str(str);
+  return true;
+}
+
+
+long
+Fl_Widget::msaa_role(long id)
+{
+  return ROLE_SYSTEM_STATICTEXT;
+}
+
+
+long
+Fl_Widget::msaa_state(long id)
+{
+  if (id != 0)  return 0;
+  return
+    (msaa_visible() ? 0 : STATE_SYSTEM_INVISIBLE) |
+    (active_r() ? 0 : STATE_SYSTEM_UNAVAILABLE) |
+    (!msaa_focusable() ? 0 : STATE_SYSTEM_FOCUSABLE) |
+    (Fl::focus() != this ? 0 : STATE_SYSTEM_FOCUSED);
+}
+
+
+bool
+Fl_Widget::msaa_help(long id, BSTR* bstr)
+{
+  if (id != 0)  return false;
+  fl_str_to_bstr(tooltip(), -1, bstr);
+  return true;
+}
+
+
+bool
+Fl_Widget::msaa_shortcut(long id, BSTR* bstr)
+{
+  const char* l = fl_label_string(label_.type, label_.value);
+  size_t len;
+  char* str = fl_label_to_shortcut(l, &len);
+  if (len)  fl_str_to_bstr(str, len, bstr);
+  fl_free_str(str);
+  return len > 0;
+}
+
+
+long
+Fl_Widget::msaa_focus()
+{
+  return (Fl::focus() == this ? 0 : -1);
+}
+
+
+bool
+Fl_Widget::msaa_do_select(long id, long flags)
+{
+  if (id > 0)  return false;
+  if (flags && SELFLAG_TAKEFOCUS)
+  {
+    take_focus();
+    return true;
+  }
+  return false;
+}
+
+
+bool
+Fl_Widget::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (id > 0)  return false;
+  if (!msaa_visible())  return false;
+
+  // Convert to screen co-ordinates
+  const Fl_Window* wnd = msaa_window();
+  *X = x();
+  *Y = y();
+  *W = w();
+  *H = h();
+  if (this != wnd)
+  {
+    // Normal widget location is relative to parent window
+    *X += wnd->x_root();
+    *Y += wnd->y_root();
+  }
+  else
+  {
+    const Fl_Window* parent_wnd = window();
+    if (parent_wnd)
+    {
+      // Sub-window location is also relative to parent window
+      *X += parent_wnd->x();
+      *Y += parent_wnd->y();
+    }
+  }
+  return true;
+}
+
+
+long
+Fl_Widget::msaa_navigate(long id, long dir)
+{
+  // Handle navigation within child widget
+  long max_id = msaa_child_count();
+  if (max_id < 1)  return -1;
+  switch (dir)
+  {
+    case NAVDIR_FIRSTCHILD:	return 1;
+    case NAVDIR_LASTCHILD:	return max_id;
+    case NAVDIR_PREVIOUS:	return (id == 1 ? -1 : (id - 1));
+    case NAVDIR_NEXT:		return (id == max_id ? -1 : (id + 1));
+
+    // Spatial navigation not implemented
+    case NAVDIR_UP:		// Fall through
+    case NAVDIR_DOWN:		// Fall through
+    case NAVDIR_LEFT:		// Fall through
+    case NAVDIR_RIGHT:		// Fall through
+    default:			return -1;
+  }
+}
+
+
+void
+Fl_Widget::msaa_notify(DWORD event, long childId)
+{
+  // Use proxy object pointer as object ID 
+  Fl_Msaa_Proxy* proxy = msaa_proxy();
+  if (!proxy)  return;
+  const Fl_Window* wnd = msaa_window();
+  if (!wnd)  return;
+  HWND hwnd = fl_xid(wnd);
+  if (!hwnd)  return;
+  NotifyWinEvent(event, hwnd, (LONG)proxy, childId);
+}
+
+
+void
+Fl_Widget::msaa_on_focus()
+{
+  msaa_notify(EVENT_OBJECT_FOCUS);
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: FL/Fl_Value_Slider.H
===================================================================
--- FL/Fl_Value_Slider.H	(revision 6732)
+++ FL/Fl_Value_Slider.H	(working copy)
@@ -60,6 +60,12 @@
     Fl_Color textcolor() const {return (Fl_Color)textcolor_;}
     /**    Sets the color of the text in the value box.  */
     void textcolor(unsigned s) {textcolor_ = s;}
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  bool msaa_location(long id, long* X, long* Y, long* W, long* H);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Enumerations.H
===================================================================
--- FL/Enumerations.H	(revision 6732)
+++ FL/Enumerations.H	(working copy)
@@ -587,6 +587,8 @@
   FL_FREE_LABELTYPE		///< first free labeltype to use for creating own labeltypes
 };
 
+FL_EXPORT const char* fl_label_string(int l_type, const char* l_text);
+
 /** 
   Sets the current  label type end return its corresponding Fl_Labeltype value. 
   @{
